      SUBROUTINE BKGIMG(NSX,NSY,SCF_MEX,FMIN,IERR)

C produces binned background-image without bright sources
C***********************************************************************
C
C   call_var.          type I/O description 
CP  IERR                I4    O error code
CP                              = 0 no error
CP  NSX                 I4  I   X-sampling for BKG-bins
CP  NSY                 I4  I   Y-sampling for BKG-bins
CP  SCALE               R4  I   background scale factor (usually 100.)
CP  IDM_X               I4  I   length of array in x-direction
CP  IDM_Y               I4  I   length of array in y-direction
CP  IEXMPX              I4  I   exposure image array
CP  SCF_MEX             R8  I   scale factor exposure image
CP  IDME_X              I4  i   length of exposure array in x-direction
CP  IDME_Y              I4  i   length of exposure array in y-direction
C
C***********************************************************************

      use global

      IMPLICIT NONE
      INCLUDE 'include/cgenl.cmn'
      INCLUDE 'include/cdbnag.cmn'

      CHARACTER*8   RTNAME
      INTEGER     I,IERR,II,J,M,N,NMAP,NSX,NSY,NX,NY,
     &              nsums,isums,isumm
      REAL        SCALE,FMIN,fnags(mtot)
      DOUBLE PRECISION SWNAG,VFNAG,VWNAG,SCF_MEX,NSUM,SEXP  

      SAVE

      IERR  = 0
      II = 0
      nsums = 0
      FMIN=1e30

      IF (MOD(IDM_X,NSX).NE.0) THEN
        NX = IDM_X/NSX + 1
      ELSE
        NX = IDM_X/NSX
      ENDIF
      IF (MOD(IDM_Y,NSY).NE.0) THEN
        NY = IDM_Y/NSY + 1
      ELSE
        NY = IDM_Y/NSY
      ENDIF

      DO N = 1,NY

C accumulate a strip with width NSX located at the position N
        DO M = 1,NX

          SEXP = 0.
          NSUM = 0.D0
          NMAP = 0

          DO J = (N-1)*NSY+1,min(ipa_y,N*NSY)
            DO  I = (M-1)*NSX+1,min(ipa_x,M*NSX)

C accumulate only if mask is .true.
              IF(MFELD(I,J).EQ.1)THEN

                NSUM = NSUM + ICHES(I,J)
                SEXP = SEXP + DBLE(IEXMP(I,J))
                NMAP = NMAP+1
              ENDIF
            ENDDO
          ENDDO

          SEXP = SEXP * SCF_MEX

C one background subcell ready / does it contain enough counts
          II = II+1 
          XNAG(II) = (DBLE(M)-0.5D0)*DBLE(NSX)
          YNAG(II) = (DBLE(N)-0.5D0)*DBLE(NSY)

          IF (NMAP.GT.1) THEN 

C determine spline parameters
            IF (SEXP.GT.1.) THEN
              FNAG(II) = (NSUM/SEXP)**0.1
            ELSE
              FNAG(II) = -999D0
            ENDIF

            ENAG(II) = SEXP/SQRT(MAX(NSUM,1D0))
            WNAG(II) = 1.0
            if (fnag(ii) > 0) then
              nsums = nsums+1
              if (nsums == 1) then
                fnags(1) = fnag(ii)
              else
                do isums=1,nsums
                  if (fnags(isums)>fnag(ii)) exit
                end do
                isums=min(nsums,isums)
                do isumm=nsums,isums+1,-1
                  fnags(isumm)=fnags(isumm-1)
                end do              
                fnags(isums)=fnag(ii)
              end if
            end if  
          ELSE

C   flag spline parameters for empty bins
            FNAG(II) = -999D0
            WNAG(II) = -999D0
            ENAG(II) = 0D0
          ENDIF

          VFNAG = FNAG(II)
          VWNAG = WNAG(II)          

C write background content to preliminary smoothed image
          DO J = (N-1)*NSY+1,min(ipa_y,N*NSY)
            DO I = (M-1)*NSX+1,min(ipa_x,M*NSX)
              IFELD(I,J) = VFNAG
              JFELD(I,J) = VWNAG
            ENDDO
          ENDDO
        ENDDO
      ENDDO
      NPTS = II
 
C put mean value on pixel that had too few counts
C they have been set to -999.

      fmin=fnags(max(nsums/5,1))
      DO II = 1,NPTS
        if (fnag(ii) .le. 0d0) then
           fnag(ii) = fmin
           wnag(ii) = 0.5
           enag(ii) = 0d0
        end if
      ENDDO

      RETURN
      END



