      SUBROUTINE EXDBIN(IPA,IECH,KMERK,X,Y,ISNR,SCTS,NOIM,NOMF,TILS,
     &                  SCF_MEX,MAX_MEX,MAX_IMG,IERR)
C
CC  input routine for main program  EXDB
C
C************************ FFORM VERSION 1.1 ************  7-NOV-89 15:12
C
CA  author : GRH        date: 14-JAN-1987 13:40
CU  update : CRI        date: 16-MAR-1988 08:52
CU  update : CRI        date: 17-MAR-1988 08:31
CU  update : PTK        date: 30-NOV-1992 21:11 read exposure image
CU  update : PTK        date: 01-DEC-1992 12:19 IEXMP,SCF_MEX,
CU                                              IDME_X,IDME_Y
CU  update : EXSAS              date: 03-AUG-1993 16:51
C
CT  status: not tested
C
C   general description 
CG  input routine for main program  DB
C
C   call_var.          type I/O description 
CP  IECH                I4  I   current energy range index
CP  IERR                I4    O = 0 no error
CP                              = 3 eof detected during read continuat.
CP                                  lines from LSLST
CP                              error code from C_FILE, O_ASCI, R_LSLST,
CP                              RRFELD or RRFELL
CP  IPA                 I4      dimension of the output arrays
CP  ISNR                R4    O array with significance for all sources
CP  KMERK               I4    O number of sources in source list
CP  X                   R4    O array with X-coordinates of sources
CP  Y                   R4    O array with Y-coordinates of sources
CP  NOIM                I4  ?/o number identifier of IMAGE
CP  NOMF                I4  ?/o number identifier of MEXBL
CP  TILS                I4      number identifier of LSLST
CP  IEXMP               I4  i/o exposure array
CP  SCF_MEX             R8    o scaling factor for exposure field
CP  IDME_X              I4  i   length of exposure array in x-direction
CP  IDME_Y              I4  i   length of exposure array in y-direction
C
C   include_block name          description 
CI  RCOMMON:CDBIMG.CMN          DB image array parameter common block
CI  RCOMMON:CDBIO.CMN           DBPAR parameter common block
CI  RCOMMON:CGENL.CMN           general parameter common block
CI  RCOMMON:CLSLST.CMN          LSLST list parameter common block
C
C   routines_called    type     description 
CR  WRFLAG              SR      writes to FLAG output stream
CR  LSLSTR              SR      read source list from MIDAS table
CR  BDFI4R              SR      read a MIDAS image, store it to I2
CR  BDFL4R              SR      read a MIDAS image, store it to L1
CR  WRERR               SR      write error message
C
C   extensions/system calls     description 
CX 
C
C***********************************************************************
C
C   variables   meaning
C
      use global

      IMPLICIT NONE
      include 'include/cgenl.cmn'
      include 'include/clslst.cmn'
      include 'include/cdbio.cmn'
!     include 'include/cdbimg.cmn'
      include 'include/cimsky.cmn'
C
      INTEGER       IDME_X,IDME_Y
      INTEGER       I, ICONT, IECH, IERR, IPA, ISTAT, IWIND,
     &              K, KMERK, LOOP, NPRIO, NREC, NTRUEX, IX, IY,
     &              NOIM, NOMF, NOME, TILS, ACV, DUN, SKY_X, SKY_Y,
     &              LM, LI, LE, LENCH, NPIXM(2), NPIXI(2), NPIXE(2),
     &              MAX_MEX, II, JJ
!      REAL           IEXMP(IDME_X,IDME_Y)  
      REAL          ABSTM, ABSTS, BKG, SRC, X(IPA), Y(IPA)
      REAL          ISNR(IPA),SCTS(IPA)
      DOUBLE PRECISION
     &              SKYPIX, STARTM(2), STEPM(2), STARTI(2), STEPI(2),
     &              STARTE(2), STEPE(2),
     &              STPF, STAF, SCF_MEX, EPSD, DDUMMY, MAX_IMG
      LOGICAL       OPEN,CLOSE,DNUL
      CHARACTER*8   RTNAME
      CHARACTER*72  TEXT
      character*1024 inst

      SAVE

      DATA          RTNAME  /'EXDBIN'/
      DATA          LOOP    /0/  
      DATA          EPSD    /1.D-9/

!     include 'include/cdbimg.inc'

      IERR = 0

C read image 
      CALL BDFI42R4R(IMAGE(IECH),NOIM,STARTI,STEPI,
     #               SKYCEN(1),SKYCEN(2),NPIXI,inst,ISTAT)
      imsize(1)=npixi(1)
      imsize(2)=npixi(2)      

      idinst=0
      if (index(inst,"EPN")>0) idinst=1
      if (index(inst,"EMOS1")>0) idinst=2
      if (index(inst,"EMOS2")>0) idinst=3

       

      IF (LOOP.EQ.0) THEN
         LOOP = 0
         SCF_MEX = 1.D0
C
         IF (DB_EXP) THEN
           CALL BDFR4R(EXPIMA(IECH),NOME,STARTE,STEPE, 
     &       skycen(1),skycen(2),NPIXE,inst,ISTAT)
           if (npixe(1) /= npixi(1) .or. 
     &         npixe(2) /= npixi(2)) 
     &       call error ("FileMismatch","Exposure map has wrong size") 

C find maximum
             MAX_MEX = IEXMP(1,1)
             DO II = 1,IDM_X
               DO JJ = 1,IDM_Y
c                 print *,ii,jj,iexmp(ii,jj)
                 IF (IEXMP(II,JJ).GT.MAX_MEX) MAX_MEX = IEXMP(II,JJ)
               ENDDO
             ENDDO
             MAX_MEX = MAX(MAX_MEX,1)

             SCF_MEX = 1.D0
         ELSE          
           allocate (iexmp(ipa_x,ipa_y))

           IDM_X = IPA_X
           IDM_Y = IPA_Y
           DO IX = 1,IDM_X
             DO IY = 1,IDM_Y
               IEXMP(IX,IY)=1.
             ENDDO
           ENDDO
           MAX_MEX = 1.
         ENDIF
C
         IF ( (IERR.LE.1) .AND. (DB_LMAP) ) THEN

C read mask image
           CALL BDFI4R(MEXBM,NOMF,STARTM,STEPM,NPIXM,inst,ISTAT)
           if (npixm(1) /= npixi(1) .or.
     &          npixm(2) /= npixi(2)) 
     &       call error ("FileMismatch","Detection mask has wrong size") 

           if (db_exp) then 
             DO IX = 1,IDM_X
               DO IY = 1,IDM_Y
                IEXMP(IX,IY)=IEXMP(IX,IY)*MFELD(IX,IY)
               END DO
             END DO
           end if

         ELSE
           allocate (mfeld(ipa_x,ipa_y))
           IDM_X = IPA_X
           IDM_Y = IPA_Y
           DO IX = 1,IDM_X
             DO IY = 1,IDM_Y
               MFELD(IX,IY)=1
             ENDDO
           ENDDO
           NTRUEX = 0
           DO IX = 1,IDM_X
             DO IY = 1,IDM_Y
               IF (MFELD(IX,IY).EQ.1) THEN
                 NTRUEX = NTRUEX + 1
               ENDIF
             ENDDO
           ENDDO
         ENDIF
      ENDIF

      IF(IERR.LE.1)THEN

C find maximum
          MAX_IMG = IFELD(1,1)
          DO II = 1,IDM_X
            DO JJ = 1,IDM_Y
              IF (IFELD(II,JJ).GT.MAX_IMG) THEN
                MAX_IMG = IFELD(II,JJ)
              ENDIF
            ENDDO
          ENDDO
          IF (MAX_IMG.LT.1.0) MAX_IMG = 1.0
           PIXEL = SNGL(DDUMMY)
           PIXIM = SNGL(DDUMMY)

          IF (.NOT.DB_LMAP) THEN
            NPIXM(1) = NPIXI(1)
            NPIXM(2) = NPIXI(2)
            STARTM(1) = STARTI(1)
            STARTM(2) = STARTI(2)
            STEPM(1)  = STEPI(1)
            STEPM(2)  = STEPI(2)
          ENDIF
      ENDIF

      allocate (iches(ipa_x,ipa_y))
      allocate (jfeld(ipa_x,ipa_y))
      allocate (iback(ipa_x,ipa_y))

      CALL LSLSTR(LSLST(IECH),IPA,KMERK,X,Y,ISNR,SCTS,idinst,DB_BAND)

      RETURN
      END
